package com.unleashedsoftware.sdk.model;

import com.unleashedsoftware.sdk.serialisation.*;
import org.codehaus.jackson.annotate.*;
import org.codehaus.jackson.map.annotate.*;
import java.util.*;

public class ApiSalesOrder {
    @JsonProperty("Guid")
    public String id;

    @JsonProperty("OrderNumber")
    public String orderNumber;

    @JsonProperty("OrderStatus")
    @JsonDeserialize(using = JsonApiSalesOrderStatusDeserialiser.class)
    public ApiSalesOrderStatus orderStatus;

    @JsonProperty("Total")
    public double total;

    @JsonProperty("SubTotal")
    public double subTotal;

    @JsonProperty("TaxTotal")
    public double taxTotal;

    @JsonProperty("BCTotal")
    public double baseCurrencyTotal;

    @JsonProperty("BCSubTotal")
    public double baseCurrencySubTotal;

    @JsonProperty("BCTaxTotal")
    public double baseCurrencyTaxTotal;

    @JsonProperty("ExchangeRate")
    public double exchangeRate;

    @JsonProperty("DiscountRate")
    public double discountRate;

    @JsonProperty("TaxRate")
    public double taxRate;

    @JsonProperty("XeroTaxCode")
    public String xeroTaxCode;

    @JsonProperty("TotalVolume")
    public double totalVolume;

    @JsonProperty("TotalWeight")
    public double totalWeight;

    @JsonProperty("SendAccountingJournalOnly")
    public boolean sendAccountingJournalOnly;

    @JsonProperty("OrderDate")
    @JsonSerialize(using = JsonDateSerialiser.class)
    @JsonDeserialize(using = JsonMicrosoftDateDeserialiser.class)
    public Date orderDate;

    @JsonProperty("QuoteExpiryDate")
    @JsonSerialize(using = JsonDateSerialiser.class)
    @JsonDeserialize(using = JsonMicrosoftDateDeserialiser.class)
    public Date quoteExpiryDate;

    @JsonProperty("RequiredDate")
    @JsonSerialize(using = JsonDateSerialiser.class)
    @JsonDeserialize(using = JsonMicrosoftDateDeserialiser.class)
    public Date requiredDate;

    @JsonProperty("ReceivedDate")
    @JsonSerialize(using = JsonDateSerialiser.class)
    @JsonDeserialize(using = JsonMicrosoftDateDeserialiser.class)
    public Date receivedDate;

    @JsonProperty("PaymentDueDate")
    @JsonSerialize(using = JsonDateSerialiser.class)
    @JsonDeserialize(using = JsonMicrosoftDateDeserialiser.class)
    public Date paymentDueDate;

    @JsonProperty("LastModifiedOn")
    @JsonSerialize(using = JsonDateSerialiser.class)
    @JsonDeserialize(using = JsonMicrosoftDateDeserialiser.class)
    public Date lastModifiedOn;

    @JsonProperty("CreatedBy")
    public String createdBy;

    @JsonProperty("Customer")
    public ApiCustomer customer;

    @JsonProperty("Warehouse")
    public ApiWarehouse warehouse;

    @JsonProperty("Currency")
    public ApiCurrency currency;

    @JsonProperty("Tax")
    public ApiTax tax;

    @JsonProperty("SalesOrderLines")
    public List<ApiSalesOrderLine> salesOrderLines;
}
