package com.unleashedsoftware.sdk.model;

import com.unleashedsoftware.sdk.serialisation.*;
import org.codehaus.jackson.annotate.*;
import org.codehaus.jackson.map.annotate.*;
import java.util.*;

public class ApiSalesOrderLine {
    @JsonProperty("Guid")
    public String id;

    @JsonProperty("LineNumber")
    public int lineNumber;

    @JsonProperty("OrderQuantity")
    public double orderQuantity;

    @JsonProperty("UnitCost")
    public double unitCost;

    @JsonProperty("UnitPrice")
    public double unitPrice;

    @JsonProperty("LineTotal")
    public double lineTotal;

    @JsonProperty("LineTax")
    public double lineTax;

    @JsonProperty("BCUnitPrice")
    public double baseCurrencyUnitPrice;

    @JsonProperty("BCLineTotal")
    public double baseCurrencyLineTotal;

    @JsonProperty("BCLineTax")
    public double baseCurrencyLineTax;

    @JsonProperty("DiscountRate")
    public double discountRate;

    @JsonProperty("TaxRate")
    public double taxRate;

    @JsonProperty("XeroTaxCode")
    public String xeroTaxCode;

    @JsonProperty("XeroSalesAccount")
    public String xeroSalesAccount;

    @JsonProperty("Volume")
    public double volume;

    @JsonProperty("Weight")
    public double weight;

    @JsonProperty("Comments")
    public String comments;

    @JsonProperty("DueDate")
    @JsonSerialize(using = JsonDateSerialiser.class)
    @JsonDeserialize(using = JsonMicrosoftDateDeserialiser.class)
    public Date dueDate;

    @JsonProperty("LastModifiedOn")
    @JsonSerialize(using = JsonDateSerialiser.class)
    @JsonDeserialize(using = JsonMicrosoftDateDeserialiser.class)
    public Date lastModifiedOn;

    @JsonProperty("Product")
    public ApiProduct product;
}