package com.unleashedsoftware.sdk.network;

import java.io.*;

public class RestClientReadWriteConnection extends RestClientConnection {
    private RestClientReadWriteConnection(RestClientConnectionConfiguration configuration) throws IOException {
        super(configuration);
    }

    public static RestClientReadWriteConnection create(RestClientConnectionConfiguration configuration) throws IOException {
        if(configuration.requestMethod == RestClientRequestMethod.get)
            throw new GetRequestMethodNotSupportedException();
        if(configuration.requestMethod == RestClientRequestMethod.delete)
            throw new DeleteRequestMethodNotSupportedException();
        return new RestClientReadWriteConnection(configuration);
    }

    protected boolean isReadable() {
        return true;
    }

    protected boolean isWritable() {
        return true;
    }

    public static class GetRequestMethodNotSupportedException extends RuntimeException {
    }

    public static class DeleteRequestMethodNotSupportedException extends RuntimeException {
    }
}
